

/*****
*
* DYNAMIKOS PROGRAMMATISMOS
* OLIKI STOIXISH
* Needleman - Wunsch
*
* By S G Fountoukis
* http://www.fountoukis.com
* https://www.fountoukis.com
*
*****/

import java.util.*;


public class BioInfo {
	
	// pinakes
	private int[][] f;
	private PreviousCell[][] trace; 
	
	// penalties
	private int match; 
	private int misMatch; 
	private int d;
	
	//Arxikes akolouthies dedomenwn
	// Edw mporoume na xrisimopoiisoume Arrays (se morfi monodiastatwn pinakwn)
	// giati gnwrizoume ta dedomena kai ara to mikos tous
	private String[] xSequence;
	private String[] ySequence;
	
	// telikes akolouthies dedomenwn gia ektypwsi se stoixismeni morfi.
	// Edw xrisimopoioume listes giati den xeroume ek twn proterwn to teliko mikos
	// twn stoixismenwn akolouthiwn logw paremvolis kenwn klp...
	private ArrayList<String> finalXSequence; // for final alignment, gia teliki stoixisi
	private ArrayList<String> finalYSequence; // for final alignment,  gia teliki stoixisi
	
	
	
	// Default Costructor
	public BioInfo() {
		//match = 1;   // for first problem
		//misMatch = -1; // and for second problem
		//d = 1;
		
		match = 2;   // for third problem
		misMatch = 0;
		d = 1;
		
	}
	
	// Constructor
	              //x=columns, y=lines
	public BioInfo(int x, int y) {
		this(); // it calls the previous constructor: BioInfo()
		xSequence = new String[x];
		ySequence = new String[y];
		f = new int[x+1][y+1]; // one more (+1) in dimensions for the f matrix for the calculations.
		trace = new PreviousCell[x+1][y+1]; // one more (+1) in dimensions for the trace matrix, similarly.
		
		finalXSequence = new ArrayList<String>();
		finalYSequence = new ArrayList<String>();
	}
	
	
	

	// Ypologizei tis times tou pinaka f[i][j] 
	// apo to aristero kelli, apo to epano kelio
	// kai apo to diagonio ano keli
	// kai epilegei tin megisti.
	
	                //i= columns, j=lines
	public void calculateF(int i, int j){
		
		
		int result1 = f[i-1][j] - d; // apo aristera
		int result2 = f[i][j-1] - d; // apo panw
		int result3;
		
		
		// apo diagoniws anw  
		// y and y Sequences are smaller in length by -1.
		if(xSequence[i-1].equals(ySequence[j-1])){ 
			result3 = f[i-1][j-1] + match;
		} else {
			result3 = f[i-1][j-1] + misMatch;
		}
		
		// telikos ypologismos tou megistou
		f[i][j] = max(result1, result2, result3);
		
		// dinetai proteraiotita sto ypologismo apo diagoniws anw
		// gia tin proeleusi tou keliou ypologismou
		// kathoson an prokypsei apo aristera or apo epanw 
		// stin ousia eisagoume keno (gap) pou den to epithimoume
		if(f[i][j] == result3){
			PreviousCell pc = new PreviousCell(i-1, j-1);
			trace[i][j] = pc;
		} else if (f[i][j] == result1) {
			PreviousCell pc = new PreviousCell(i-1, j); // apo aristera
			trace[i][j] = pc;
		} else {
			PreviousCell pc = new PreviousCell(i, j-1); // apo panw
			trace[i][j] = pc;
		}
		
		

	}

	
	public int max(int x, int y, int z) {
		
		// int w = Math.max(x, y);
		// int result = Math.max(w, z);
		
		int w = max(x, y);
		int result = max(w, z);
		
		return result;
	}
	
	
	
	public int max(int x, int y){
		
		int result;
		
		if (x > y){
			result = x;
		} else  {
			result = y;
		}
		
		return result;
	}
	
	
	
	
	
	public static void main(String[] args) {
		
		
		// Edw topotetoume ta dedomena
		// diladi tis arxikes symvoloseires
		
		/*
		
		BioInfo binf = new BioInfo(4, 3);
		
		binf.xSequence[0] = "A";
		binf.xSequence[1] = "G";
		binf.xSequence[2] = "T";
		binf.xSequence[3] = "A";
		
		binf.ySequence[0] = "A";
		binf.ySequence[1] = "T";
		binf.ySequence[2] = "A";
		
		*/
		
		
		
		/*
		
		BioInfo binf = new BioInfo(5, 4);
		
		binf.xSequence[0] = "A";
		binf.xSequence[1] = "G";
		binf.xSequence[2] = "T";
		binf.xSequence[3] = "A";
		binf.xSequence[4] = "C";
		
		binf.ySequence[0] = "A";
		binf.ySequence[1] = "G";
		binf.ySequence[2] = "A";
		binf.ySequence[3] = "C";
		
		*/
		
		
		
		
		
		BioInfo binf = new BioInfo(9, 9);
		
		binf.xSequence[0] = "T";
		binf.xSequence[1] = "G";
		binf.xSequence[2] = "C";
		binf.xSequence[3] = "A";
		binf.xSequence[4] = "A";
		binf.xSequence[5] = "T";
		binf.xSequence[6] = "C";
		binf.xSequence[7] = "G";
		binf.xSequence[8] = "G";
		
		binf.ySequence[0] = "A";
		binf.ySequence[1] = "A";
		binf.ySequence[2] = "C";
		binf.ySequence[3] = "T";
		binf.ySequence[4] = "G";
		binf.ySequence[5] = "A";
		binf.ySequence[6] = "A";
		binf.ySequence[7] = "T";
		binf.ySequence[8] = "C";
		
		
		
		
		
		
		
		// fill the 0 line and 0 column of the F[i][j] table
		for(int i=0; i<binf.f.length; i++){
			binf.f[i][0] = -i*binf.d;
		}
		
		for(int j=0; j<binf.f[0].length; j++){
			binf.f[0][j] = -j*binf.d;
		}
		
		
		
		// fill the remaining cells of the F[i][j] table
		for(int j=1; j<binf.f[0].length; j++){
			
			
			for(int i=1; i<binf.f.length; i++){
				
				binf.calculateF(i, j); // it calls calculateF(i, j) to find the maximum...
				
			}
			
		}
		
		
		
		// print the F[i][j] table
		for(int j=0; j<binf.f[0].length; j++){
			
			System.out.println();
			
			for(int i=0; i<binf.f.length; i++){
				
				if(binf.f[i][j] >= 0) {
					System.out.print(" "+binf.f[i][j]+" ");
				} else {
					System.out.print(binf.f[i][j]+" ");
				}
				
				
			}
			
		}
		
		System.out.println();
		System.out.println();
		
		System.out.println("The path is:");
		int x = binf.f.length - 1; // array indexes less by -1 compared to lengths
		int y = binf.f[0].length -1;
		
		int lastX = x;
		int lastY = y;
		
		// print the position of bottom right cell.
		if(x == 0 && y == 0) { 
			System.out.print(x+","+y);
		} else {
			System.out.print(x+","+y+" <=> ");
		}
		
		
        // find the PreviousCell from which the calculation derived.
		PreviousCell prc = binf.trace[x][y]; 
	
		
		
		// Print and store repeatedly the positions of the remaining PreviousCells until to reach the start point (0,0). 
		while (!(prc == null && x == 0  && y == 0))  { // In the position (0,0) of the trace table there is NO PreviousCell, it is null (empty).
			
			if (prc != null) {
			x = prc.getX();
		    y = prc.getY();
			} else if (x == 0 && y > 0){
				y = y - 1;
			} else if (y == 0 && x > 0) {
				x = x - 1;
			} else if (x == 0 && y == 0) {
				break;
			}
			
			
			
			if (x==lastX-1 && y==lastY-1){
				binf.finalXSequence.add(binf.xSequence[x]);
				binf.finalYSequence.add(binf.ySequence[y]);
			} else if (x==lastX-1 && y==lastY){
				binf.finalXSequence.add(binf.xSequence[x]);
				binf.finalYSequence.add("-");
				
			}	else {
				binf.finalXSequence.add("-");
				binf.finalYSequence.add(binf.ySequence[y]);
				
			}
			
		
			
			if(x == 0 && y == 0) {
			   System.out.print(x+","+y);
			} else {
			  System.out.print(x+","+y+" <=> ");
			}
			
			
			lastX = x;
			lastY = y;
			
			prc = binf.trace[x][y];   // find the next PreviousCell, going always back...
			
		}
		
		
		
		System.out.println();
		System.out.println();
		
		
		// Ektypwsi telikwn stoixismenwn akolouthiwn
		// Ektypwnoume tis sxetikes listes anastrofa
		// gia na fanoun kanonika, afou anastrofa
		// tis gemisame.
		System.out.println("Alignment of Sequences:");
		
		for (int i = binf.finalXSequence.size() - 1; i >= 0; i--) {
			
		    String str = binf.finalXSequence.get(i);
		    System.out.print(str+" ");
		  
	    }
			
		System.out.println();
			
		for (int j = binf.finalYSequence.size() - 1; j >= 0; j--) {
			
		    String str = binf.finalYSequence.get(j);
		    System.out.print(str+" ");
		  
	    }
		
		System.out.println();
		System.out.println();		
			
		
	
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
}







